# eric4.PluginManager.PluginRepositoryDialog

Module implementing a dialog showing the available plugins.

### Global Attributes

authorRole
descrRole
filenameRole
urlRole

### Classes

PluginRepositoryDialog | Class for the dialog variant.
PluginRepositoryWidget | Class implementing a dialog showing the available plugins.
PluginRepositoryWindow | Main window class for the standalone dialog.

### Functions

None

## PluginRepositoryDialog

Class for the dialog variant.

### Derived from

QDialog

### Class Attributes

None

### Methods

PluginRepositoryDialog | Constructor
__closeAndInstall | Private slot to handle the closeAndInstall signal.
getDownloadedPlugins | Public method to get the list of recently downloaded plugin files.

#### PluginRepositoryDialog (Constructor)

PluginRepositoryDialog(parent = None)

Constructor

parent
  reference to the parent widget (QWidget)

#### PluginRepositoryDialog.__closeAndInstall

__closeAndInstall()

Private slot to handle the closeAndInstall signal.

#### PluginRepositoryDialog.getDownloadedPlugins

getDownloadedPlugins()

Public method to get the list of recently downloaded plugin files.

Returns:
  list of plugin filenames (QStringList)

Up

## PluginRepositoryWidget

Class implementing a dialog showing the available plugins.

#### Signals

closeAndInstall
  emitted when the Close & Install button is pressed

### Derived from

QWidget, Ui_PluginRepositoryDialog

### Class Attributes

None

### Methods

PluginRepositoryWidget | Constructor
__dataReadProgress | Private slot to show the download progress.
__downloadCancel | Private slot to cancel the current download.
__downloadFile | Private slot to download the given file.
__downloadFileDone | Private method called, after the file has been downloaded from the internet.
__downloadPlugin | Private method to download the next plugin.
__downloadPluginDone | Private method called, when the download of a plugin is finished.
__downloadPlugins | Private slot to download the selected plugins.
__downloadPluginsDone | Private method called, when the download of the plugins is finished.
__downloadRepositoryFileDone | Private method called after the repository file was downloaded.
__formatDescription | Private method to format the description.
__isUpToDate | Private method to check, if the given archive is up-to-date.
__populateList | Private method to populate the list of available plugins.
__proxyAuthenticationRequired | Private slot to handle a proxy authentication request.
__resortRepositoryList | Private method to resort the tree.
__selectedItems | Private method to get all selected items without the toplevel ones.
__sslErrors | Private slot to handle SSL errors.
__updateList | Private slot to download a new list and display the contents.
addEntry | Public method to add an entry to the list.
getDownloadedPlugins | Public method to get the list of recently downloaded plugin files.
on_buttonBox_clicked | Private slot to handle the click of a button of the button box.
on_repositoryList_currentItemChanged | Private slot to handle the change of the current item.
on_repositoryList_itemSelectionChanged | Private slot to handle a change of the selection.

#### PluginRepositoryWidget (Constructor)

PluginRepositoryWidget(parent = None)

Constructor

parent
  parent of this dialog (QWidget)

#### PluginRepositoryWidget.__dataReadProgress

__dataReadProgress(done, total)

Private slot to show the download progress.

done
  number of bytes downloaded so far (integer)
total
  total bytes to be downloaded (integer)

#### PluginRepositoryWidget.__downloadCancel

__downloadCancel()

Private slot to cancel the current download.

#### PluginRepositoryWidget.__downloadFile

__downloadFile(url, filename, doneMethod = None)

Private slot to download the given file.

url
  URL for the download (string or QString)
filename
  local name of the file (string or QString)
doneMethod
  method to be called when done

#### PluginRepositoryWidget.__downloadFileDone

__downloadFileDone(error)

Private method called, after the file has been downloaded from the internet.

error
  flag indicating an error condition (boolean)

#### PluginRepositoryWidget.__downloadPlugin

__downloadPlugin()

Private method to download the next plugin.

#### PluginRepositoryWidget.__downloadPluginDone

__downloadPluginDone(status, filename)

Private method called, when the download of a plugin is finished.

status
  flaging indicating a successful download (boolean)
filename
  full path of the downloaded file (QString)

#### PluginRepositoryWidget.__downloadPlugins

__downloadPlugins()

Private slot to download the selected plugins.

#### PluginRepositoryWidget.__downloadPluginsDone

__downloadPluginsDone()

Private method called, when the download of the plugins is finished.

#### PluginRepositoryWidget.__downloadRepositoryFileDone

__downloadRepositoryFileDone(status, filename)

Private method called after the repository file was downloaded.

status
  flaging indicating a successful download (boolean)
filename
  full path of the downloaded file (QString)

#### PluginRepositoryWidget.__formatDescription

__formatDescription(lines)

Private method to format the description.

lines
  lines of the description (QStringList)

Returns:
  formatted description (QString)

#### PluginRepositoryWidget.__isUpToDate

__isUpToDate(filename, version)

Private method to check, if the given archive is up-to-date.

filename
  data for the filename field (string or QString)
version
  data for the version field (string or QString)

Returns:
  flag indicating up-to-date (boolean)

#### PluginRepositoryWidget.__populateList

__populateList()

Private method to populate the list of available plugins.

#### PluginRepositoryWidget.__proxyAuthenticationRequired

__proxyAuthenticationRequired(proxy, auth)

Private slot to handle a proxy authentication request.

proxy
  reference to the proxy object (QNetworkProxy)
auth
  reference to the authenticator object (QAuthenticator)

#### PluginRepositoryWidget.__resortRepositoryList

__resortRepositoryList()

Private method to resort the tree.

#### PluginRepositoryWidget.__selectedItems

__selectedItems()

Private method to get all selected items without the toplevel ones.

Returns:
  list of selected items (QList)

#### PluginRepositoryWidget.__sslErrors

__sslErrors(sslErrors)

Private slot to handle SSL errors.

sslErrors
  list of SSL errors (list of QSslError)

#### PluginRepositoryWidget.__updateList

__updateList()

Private slot to download a new list and display the contents.

#### PluginRepositoryWidget.addEntry

addEntry(name, short, description, url, author, version, filename, status)

Public method to add an entry to the list.

name
  data for the name field (string or QString)
short
  data for the short field (string or QString)
description
  data for the description field (list of string or QStringList)
url
  data for the url field (string or QString)
author
  data for the author field (string or QString)
version
  data for the version field (string or QString)
filename
  data for the filename field (string or QString)
status
  status of the plugin (string [stable, unstable, unknown])

#### PluginRepositoryWidget.getDownloadedPlugins

getDownloadedPlugins()

Public method to get the list of recently downloaded plugin files.

Returns:
  list of plugin filenames (QStringList)

#### PluginRepositoryWidget.on_buttonBox_clicked

on_buttonBox_clicked(button)

Private slot to handle the click of a button of the button box.

#### PluginRepositoryWidget.on_repositoryList_currentItemChanged

on_repositoryList_currentItemChanged(current, previous)

Private slot to handle the change of the current item.

current
  reference to the new current item (QTreeWidgetItem)
previous
  reference to the old current item (QTreeWidgetItem)

#### PluginRepositoryWidget.on_repositoryList_itemSelectionChanged

on_repositoryList_itemSelectionChanged()

Private slot to handle a change of the selection.

Up

## PluginRepositoryWindow

Main window class for the standalone dialog.

### Derived from

KQMainWindow

### Class Attributes

None

### Methods

PluginRepositoryWindow | Constructor
__startPluginInstall | Private slot to start the eric4 plugin installation dialog.

#### PluginRepositoryWindow (Constructor)

PluginRepositoryWindow(parent = None)

Constructor

parent
  reference to the parent widget (QWidget)

#### PluginRepositoryWindow.__startPluginInstall

__startPluginInstall()

Private slot to start the eric4 plugin installation dialog.

Up